//
// DmasAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class DmasAPI {
    /**
     * enum for parameter fields
     */
    public enum Fields_dmasDmaIdDaysDateGet: String { 
        case timestampinit = "timestampInit"
        case uvindexmax = "uvIndexMax"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_dmasDmaIdDaysDateGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A day of UV data for a DMA.

     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter date: (path) An date formatted as a RFC3339 date value. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func dmasDmaIdDaysDateGet(dmaId: Int, date: Date, fields: [String], unitScale: UnitScale_dmasDmaIdDaysDateGet? = nil, completion: @escaping ((_ data: UvDmaDayObj?,_ error: Error?) -> Void)) {
        dmasDmaIdDaysDateGetWithRequestBuilder(dmaId: dmaId, date: date, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A day of UV data for a DMA.
     - GET /dmas/{dmaId}/days/{date}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "uv" : [ {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  }, {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  } ],
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+00:00",
    "dateEnd" : "2019-12-20T00:00:00.000+00:00"
  },
  "location" : {
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "dmaId" : 529,
    "dmaName" : "Louisville",
    "countryName" : "United States of America",
    "samplePoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    } ],
    "population" : 1584746
  },
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndexMax" : "UV Index (unitless)"
    }
  }
}}]
     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter date: (path) An date formatted as a RFC3339 date value. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvDmaDayObj> 
     */
    open class func dmasDmaIdDaysDateGetWithRequestBuilder(dmaId: Int, date: Date, fields: [String], unitScale: UnitScale_dmasDmaIdDaysDateGet? = nil) -> RequestBuilder<UvDmaDayObj> {
        var path = "/dmas/{dmaId}/days/{date}"
        let dmaIdPreEscape = "\(dmaId)"
        let dmaIdPostEscape = dmaIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dmaId}", with: dmaIdPostEscape, options: .literal, range: nil)
        let datePreEscape = "\(date)"
        let datePostEscape = datePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{date}", with: datePostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvDmaDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_dmasDmaIdDaysDateStartdateEndGet: String { 
        case timestampinit = "timestampInit"
        case uvindexmax = "uvIndexMax"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_dmasDmaIdDaysDateStartdateEndGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A contiguous range of daily UV data for a DMA.

     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter dateStart: (path) An date formatted as a RFC3339 date value that must occur temporally before dateEnd. 
     - parameter dateEnd: (path) An date formatted as a RFC3339 date value that must occur temporally after dateStart. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func dmasDmaIdDaysDateStartdateEndGet(dmaId: Int, dateStart: Date, dateEnd: Date, fields: [String], unitScale: UnitScale_dmasDmaIdDaysDateStartdateEndGet? = nil, completion: @escaping ((_ data: UvDmaDayObj?,_ error: Error?) -> Void)) {
        dmasDmaIdDaysDateStartdateEndGetWithRequestBuilder(dmaId: dmaId, dateStart: dateStart, dateEnd: dateEnd, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A contiguous range of daily UV data for a DMA.
     - GET /dmas/{dmaId}/days/{dateStart},{dateEnd}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "uv" : [ {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  }, {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  } ],
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+00:00",
    "dateEnd" : "2019-12-20T00:00:00.000+00:00"
  },
  "location" : {
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "dmaId" : 529,
    "dmaName" : "Louisville",
    "countryName" : "United States of America",
    "samplePoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    } ],
    "population" : 1584746
  },
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndexMax" : "UV Index (unitless)"
    }
  }
}}]
     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter dateStart: (path) An date formatted as a RFC3339 date value that must occur temporally before dateEnd. 
     - parameter dateEnd: (path) An date formatted as a RFC3339 date value that must occur temporally after dateStart. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvDmaDayObj> 
     */
    open class func dmasDmaIdDaysDateStartdateEndGetWithRequestBuilder(dmaId: Int, dateStart: Date, dateEnd: Date, fields: [String], unitScale: UnitScale_dmasDmaIdDaysDateStartdateEndGet? = nil) -> RequestBuilder<UvDmaDayObj> {
        var path = "/dmas/{dmaId}/days/{dateStart},{dateEnd}"
        let dmaIdPreEscape = "\(dmaId)"
        let dmaIdPostEscape = dmaIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dmaId}", with: dmaIdPostEscape, options: .literal, range: nil)
        let dateStartPreEscape = "\(dateStart)"
        let dateStartPostEscape = dateStartPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dateStart}", with: dateStartPostEscape, options: .literal, range: nil)
        let dateEndPreEscape = "\(dateEnd)"
        let dateEndPostEscape = dateEndPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dateEnd}", with: dateEndPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvDmaDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_dmasDmaIdDaysGet: String { 
        case timestampinit = "timestampInit"
        case uvindexmax = "uvIndexMax"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_dmasDmaIdDaysGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     The complete daily UV forecast for a DMA.

     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func dmasDmaIdDaysGet(dmaId: Int, fields: [String], unitScale: UnitScale_dmasDmaIdDaysGet? = nil, completion: @escaping ((_ data: UvDmaDayObj?,_ error: Error?) -> Void)) {
        dmasDmaIdDaysGetWithRequestBuilder(dmaId: dmaId, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     The complete daily UV forecast for a DMA.
     - GET /dmas/{dmaId}/days

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "uv" : [ {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  }, {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  } ],
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+00:00",
    "dateEnd" : "2019-12-20T00:00:00.000+00:00"
  },
  "location" : {
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "dmaId" : 529,
    "dmaName" : "Louisville",
    "countryName" : "United States of America",
    "samplePoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    } ],
    "population" : 1584746
  },
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndexMax" : "UV Index (unitless)"
    }
  }
}}]
     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvDmaDayObj> 
     */
    open class func dmasDmaIdDaysGetWithRequestBuilder(dmaId: Int, fields: [String], unitScale: UnitScale_dmasDmaIdDaysGet? = nil) -> RequestBuilder<UvDmaDayObj> {
        var path = "/dmas/{dmaId}/days"
        let dmaIdPreEscape = "\(dmaId)"
        let dmaIdPostEscape = dmaIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dmaId}", with: dmaIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvDmaDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_dmasDmaIdHoursGet: String { 
        case timestampinit = "timestampInit"
        case uvindex = "uvIndex"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_dmasDmaIdHoursGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     The complete hourly UV forecast for a DMA

     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func dmasDmaIdHoursGet(dmaId: Int, fields: [String], unitScale: UnitScale_dmasDmaIdHoursGet? = nil, completion: @escaping ((_ data: UvDmaHourObj?,_ error: Error?) -> Void)) {
        dmasDmaIdHoursGetWithRequestBuilder(dmaId: dmaId, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     The complete hourly UV forecast for a DMA
     - GET /dmas/{dmaId}/hours

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "uv" : [ {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "dmaId" : 529,
    "dmaName" : "Louisville",
    "countryName" : "United States of America",
    "samplePoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    } ],
    "population" : 1584746
  },
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndex" : "UV Index (unitless)"
    }
  }
}}]
     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvDmaHourObj> 
     */
    open class func dmasDmaIdHoursGetWithRequestBuilder(dmaId: Int, fields: [String], unitScale: UnitScale_dmasDmaIdHoursGet? = nil) -> RequestBuilder<UvDmaHourObj> {
        var path = "/dmas/{dmaId}/hours"
        let dmaIdPreEscape = "\(dmaId)"
        let dmaIdPostEscape = dmaIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dmaId}", with: dmaIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvDmaHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_dmasDmaIdHoursTimestampGet: String { 
        case timestampinit = "timestampInit"
        case uvindex = "uvIndex"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_dmasDmaIdHoursTimestampGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     An hour of UV data for a DMA

     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter timestamp: (path) A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func dmasDmaIdHoursTimestampGet(dmaId: Int, timestamp: Date, fields: [String], unitScale: UnitScale_dmasDmaIdHoursTimestampGet? = nil, completion: @escaping ((_ data: UvDmaHourObj?,_ error: Error?) -> Void)) {
        dmasDmaIdHoursTimestampGetWithRequestBuilder(dmaId: dmaId, timestamp: timestamp, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     An hour of UV data for a DMA
     - GET /dmas/{dmaId}/hours/{timestamp}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "uv" : [ {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "dmaId" : 529,
    "dmaName" : "Louisville",
    "countryName" : "United States of America",
    "samplePoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    } ],
    "population" : 1584746
  },
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndex" : "UV Index (unitless)"
    }
  }
}}]
     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter timestamp: (path) A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvDmaHourObj> 
     */
    open class func dmasDmaIdHoursTimestampGetWithRequestBuilder(dmaId: Int, timestamp: Date, fields: [String], unitScale: UnitScale_dmasDmaIdHoursTimestampGet? = nil) -> RequestBuilder<UvDmaHourObj> {
        var path = "/dmas/{dmaId}/hours/{timestamp}"
        let dmaIdPreEscape = "\(dmaId)"
        let dmaIdPostEscape = dmaIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dmaId}", with: dmaIdPostEscape, options: .literal, range: nil)
        let timestampPreEscape = "\(timestamp)"
        let timestampPostEscape = timestampPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestamp}", with: timestampPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvDmaHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_dmasDmaIdHoursTimestampStarttimestampEndGet: String { 
        case timestampinit = "timestampInit"
        case uvindex = "uvIndex"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_dmasDmaIdHoursTimestampStarttimestampEndGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A contiguous range of hourly UV data for a DMA.

     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter timestampStart: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. 
     - parameter timestampEnd: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func dmasDmaIdHoursTimestampStarttimestampEndGet(dmaId: Int, timestampStart: Date, timestampEnd: Date, fields: [String], unitScale: UnitScale_dmasDmaIdHoursTimestampStarttimestampEndGet? = nil, completion: @escaping ((_ data: UvDmaHourObj?,_ error: Error?) -> Void)) {
        dmasDmaIdHoursTimestampStarttimestampEndGetWithRequestBuilder(dmaId: dmaId, timestampStart: timestampStart, timestampEnd: timestampEnd, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A contiguous range of hourly UV data for a DMA.
     - GET /dmas/{dmaId}/hours/{timestampStart},{timestampEnd}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "uv" : [ {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "dmaId" : 529,
    "dmaName" : "Louisville",
    "countryName" : "United States of America",
    "samplePoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    } ],
    "population" : 1584746
  },
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndex" : "UV Index (unitless)"
    }
  }
}}]
     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter timestampStart: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. 
     - parameter timestampEnd: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvDmaHourObj> 
     */
    open class func dmasDmaIdHoursTimestampStarttimestampEndGetWithRequestBuilder(dmaId: Int, timestampStart: Date, timestampEnd: Date, fields: [String], unitScale: UnitScale_dmasDmaIdHoursTimestampStarttimestampEndGet? = nil) -> RequestBuilder<UvDmaHourObj> {
        var path = "/dmas/{dmaId}/hours/{timestampStart},{timestampEnd}"
        let dmaIdPreEscape = "\(dmaId)"
        let dmaIdPostEscape = dmaIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dmaId}", with: dmaIdPostEscape, options: .literal, range: nil)
        let timestampStartPreEscape = "\(timestampStart)"
        let timestampStartPostEscape = timestampStartPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestampStart}", with: timestampStartPostEscape, options: .literal, range: nil)
        let timestampEndPreEscape = "\(timestampEnd)"
        let timestampEndPostEscape = timestampEndPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestampEnd}", with: timestampEndPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvDmaHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
