//
// OnpointsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class OnpointsAPI {
    /**
     * enum for parameter fields
     */
    public enum Fields_onpointsOnpointIdDaysDateGet: String { 
        case timestampinit = "timestampInit"
        case uvindexmax = "uvIndexMax"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_onpointsOnpointIdDaysDateGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A day of UV data for an OnPoint™ point.

     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter date: (path) An date formatted as a RFC3339 date value. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func onpointsOnpointIdDaysDateGet(onpointId: Int, date: Date, fields: [String], unitScale: UnitScale_onpointsOnpointIdDaysDateGet? = nil, completion: @escaping ((_ data: UvOnpointDayObj?,_ error: Error?) -> Void)) {
        onpointsOnpointIdDaysDateGetWithRequestBuilder(onpointId: onpointId, date: date, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A day of UV data for an OnPoint™ point.
     - GET /onpoints/{onpointId}/days/{date}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "uv" : [ {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  }, {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  } ],
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+00:00",
    "dateEnd" : "2019-12-20T00:00:00.000+00:00"
  },
  "location" : {
    "onpointId" : 10725864,
    "elevation" : 173.5,
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndexMax" : "UV Index (unitless)"
    }
  }
}}]
     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter date: (path) An date formatted as a RFC3339 date value. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvOnpointDayObj> 
     */
    open class func onpointsOnpointIdDaysDateGetWithRequestBuilder(onpointId: Int, date: Date, fields: [String], unitScale: UnitScale_onpointsOnpointIdDaysDateGet? = nil) -> RequestBuilder<UvOnpointDayObj> {
        var path = "/onpoints/{onpointId}/days/{date}"
        let onpointIdPreEscape = "\(onpointId)"
        let onpointIdPostEscape = onpointIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{onpointId}", with: onpointIdPostEscape, options: .literal, range: nil)
        let datePreEscape = "\(date)"
        let datePostEscape = datePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{date}", with: datePostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvOnpointDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_onpointsOnpointIdDaysDateStartdateEndGet: String { 
        case timestampinit = "timestampInit"
        case uvindexmax = "uvIndexMax"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_onpointsOnpointIdDaysDateStartdateEndGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A contiguous range of daily UV data for an OnPoint™ point.

     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter dateStart: (path) An date formatted as a RFC3339 date value that must occur temporally before dateEnd. 
     - parameter dateEnd: (path) An date formatted as a RFC3339 date value that must occur temporally after dateStart. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func onpointsOnpointIdDaysDateStartdateEndGet(onpointId: Int, dateStart: Date, dateEnd: Date, fields: [String], unitScale: UnitScale_onpointsOnpointIdDaysDateStartdateEndGet? = nil, completion: @escaping ((_ data: UvOnpointDayObj?,_ error: Error?) -> Void)) {
        onpointsOnpointIdDaysDateStartdateEndGetWithRequestBuilder(onpointId: onpointId, dateStart: dateStart, dateEnd: dateEnd, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A contiguous range of daily UV data for an OnPoint™ point.
     - GET /onpoints/{onpointId}/days/{dateStart},{dateEnd}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "uv" : [ {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  }, {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  } ],
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+00:00",
    "dateEnd" : "2019-12-20T00:00:00.000+00:00"
  },
  "location" : {
    "onpointId" : 10725864,
    "elevation" : 173.5,
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndexMax" : "UV Index (unitless)"
    }
  }
}}]
     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter dateStart: (path) An date formatted as a RFC3339 date value that must occur temporally before dateEnd. 
     - parameter dateEnd: (path) An date formatted as a RFC3339 date value that must occur temporally after dateStart. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvOnpointDayObj> 
     */
    open class func onpointsOnpointIdDaysDateStartdateEndGetWithRequestBuilder(onpointId: Int, dateStart: Date, dateEnd: Date, fields: [String], unitScale: UnitScale_onpointsOnpointIdDaysDateStartdateEndGet? = nil) -> RequestBuilder<UvOnpointDayObj> {
        var path = "/onpoints/{onpointId}/days/{dateStart},{dateEnd}"
        let onpointIdPreEscape = "\(onpointId)"
        let onpointIdPostEscape = onpointIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{onpointId}", with: onpointIdPostEscape, options: .literal, range: nil)
        let dateStartPreEscape = "\(dateStart)"
        let dateStartPostEscape = dateStartPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dateStart}", with: dateStartPostEscape, options: .literal, range: nil)
        let dateEndPreEscape = "\(dateEnd)"
        let dateEndPostEscape = dateEndPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dateEnd}", with: dateEndPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvOnpointDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_onpointsOnpointIdDaysGet: String { 
        case timestampinit = "timestampInit"
        case uvindexmax = "uvIndexMax"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_onpointsOnpointIdDaysGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     The complete daily UV forecast for an OnPoint™ point.

     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func onpointsOnpointIdDaysGet(onpointId: Int, fields: [String], unitScale: UnitScale_onpointsOnpointIdDaysGet? = nil, completion: @escaping ((_ data: UvOnpointDayObj?,_ error: Error?) -> Void)) {
        onpointsOnpointIdDaysGetWithRequestBuilder(onpointId: onpointId, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     The complete daily UV forecast for an OnPoint™ point.
     - GET /onpoints/{onpointId}/days

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "uv" : [ {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  }, {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  } ],
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+00:00",
    "dateEnd" : "2019-12-20T00:00:00.000+00:00"
  },
  "location" : {
    "onpointId" : 10725864,
    "elevation" : 173.5,
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndexMax" : "UV Index (unitless)"
    }
  }
}}]
     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvOnpointDayObj> 
     */
    open class func onpointsOnpointIdDaysGetWithRequestBuilder(onpointId: Int, fields: [String], unitScale: UnitScale_onpointsOnpointIdDaysGet? = nil) -> RequestBuilder<UvOnpointDayObj> {
        var path = "/onpoints/{onpointId}/days"
        let onpointIdPreEscape = "\(onpointId)"
        let onpointIdPostEscape = onpointIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{onpointId}", with: onpointIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvOnpointDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_onpointsOnpointIdHoursGet: String { 
        case timestampinit = "timestampInit"
        case uvindex = "uvIndex"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_onpointsOnpointIdHoursGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     The complete hourly UV forecast for an OnPoint™ point.

     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func onpointsOnpointIdHoursGet(onpointId: Int, fields: [String], unitScale: UnitScale_onpointsOnpointIdHoursGet? = nil, completion: @escaping ((_ data: UvOnpointHourObj?,_ error: Error?) -> Void)) {
        onpointsOnpointIdHoursGetWithRequestBuilder(onpointId: onpointId, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     The complete hourly UV forecast for an OnPoint™ point.
     - GET /onpoints/{onpointId}/hours

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "onpointId" : 10725864,
    "elevation" : 173.5,
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndex" : "UV Index (unitless)"
    }
  }
}}]
     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvOnpointHourObj> 
     */
    open class func onpointsOnpointIdHoursGetWithRequestBuilder(onpointId: Int, fields: [String], unitScale: UnitScale_onpointsOnpointIdHoursGet? = nil) -> RequestBuilder<UvOnpointHourObj> {
        var path = "/onpoints/{onpointId}/hours"
        let onpointIdPreEscape = "\(onpointId)"
        let onpointIdPostEscape = onpointIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{onpointId}", with: onpointIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvOnpointHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_onpointsOnpointIdHoursTimestampGet: String { 
        case timestampinit = "timestampInit"
        case uvindex = "uvIndex"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_onpointsOnpointIdHoursTimestampGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     An hour of UV data for an OnPoint™ point.

     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter timestamp: (path) A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func onpointsOnpointIdHoursTimestampGet(onpointId: Int, timestamp: Date, fields: [String], unitScale: UnitScale_onpointsOnpointIdHoursTimestampGet? = nil, completion: @escaping ((_ data: UvOnpointHourObj?,_ error: Error?) -> Void)) {
        onpointsOnpointIdHoursTimestampGetWithRequestBuilder(onpointId: onpointId, timestamp: timestamp, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     An hour of UV data for an OnPoint™ point.
     - GET /onpoints/{onpointId}/hours/{timestamp}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "onpointId" : 10725864,
    "elevation" : 173.5,
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndex" : "UV Index (unitless)"
    }
  }
}}]
     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter timestamp: (path) A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvOnpointHourObj> 
     */
    open class func onpointsOnpointIdHoursTimestampGetWithRequestBuilder(onpointId: Int, timestamp: Date, fields: [String], unitScale: UnitScale_onpointsOnpointIdHoursTimestampGet? = nil) -> RequestBuilder<UvOnpointHourObj> {
        var path = "/onpoints/{onpointId}/hours/{timestamp}"
        let onpointIdPreEscape = "\(onpointId)"
        let onpointIdPostEscape = onpointIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{onpointId}", with: onpointIdPostEscape, options: .literal, range: nil)
        let timestampPreEscape = "\(timestamp)"
        let timestampPostEscape = timestampPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestamp}", with: timestampPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvOnpointHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_onpointsOnpointIdHoursTimestampStarttimestampEndGet: String { 
        case timestampinit = "timestampInit"
        case uvindex = "uvIndex"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_onpointsOnpointIdHoursTimestampStarttimestampEndGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A contiguous range of hourly UV data for an OnPoint™ point.

     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter timestampStart: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. 
     - parameter timestampEnd: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func onpointsOnpointIdHoursTimestampStarttimestampEndGet(onpointId: Int, timestampStart: Date, timestampEnd: Date, fields: [String], unitScale: UnitScale_onpointsOnpointIdHoursTimestampStarttimestampEndGet? = nil, completion: @escaping ((_ data: UvOnpointHourObj?,_ error: Error?) -> Void)) {
        onpointsOnpointIdHoursTimestampStarttimestampEndGetWithRequestBuilder(onpointId: onpointId, timestampStart: timestampStart, timestampEnd: timestampEnd, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A contiguous range of hourly UV data for an OnPoint™ point.
     - GET /onpoints/{onpointId}/hours/{timestampStart},{timestampEnd}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "onpointId" : 10725864,
    "elevation" : 173.5,
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndex" : "UV Index (unitless)"
    }
  }
}}]
     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter timestampStart: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. 
     - parameter timestampEnd: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvOnpointHourObj> 
     */
    open class func onpointsOnpointIdHoursTimestampStarttimestampEndGetWithRequestBuilder(onpointId: Int, timestampStart: Date, timestampEnd: Date, fields: [String], unitScale: UnitScale_onpointsOnpointIdHoursTimestampStarttimestampEndGet? = nil) -> RequestBuilder<UvOnpointHourObj> {
        var path = "/onpoints/{onpointId}/hours/{timestampStart},{timestampEnd}"
        let onpointIdPreEscape = "\(onpointId)"
        let onpointIdPostEscape = onpointIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{onpointId}", with: onpointIdPostEscape, options: .literal, range: nil)
        let timestampStartPreEscape = "\(timestampStart)"
        let timestampStartPostEscape = timestampStartPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestampStart}", with: timestampStartPostEscape, options: .literal, range: nil)
        let timestampEndPreEscape = "\(timestampEnd)"
        let timestampEndPostEscape = timestampEndPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestampEnd}", with: timestampEndPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvOnpointHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
