//
// PostcodesAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class PostcodesAPI {
    /**
     * enum for parameter fields
     */
    public enum Fields_postcodesPostcodecountryCodeDaysDateGet: String { 
        case timestampinit = "timestampInit"
        case uvindexmax = "uvIndexMax"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_postcodesPostcodecountryCodeDaysDateGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A day of UV data for a postcode.

     - parameter postcode: (path) A postcode string. 
     - parameter countryCode: (path) An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). 
     - parameter date: (path) An date formatted as a RFC3339 date value. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func postcodesPostcodecountryCodeDaysDateGet(postcode: String, countryCode: String, date: Date, fields: [String], unitScale: UnitScale_postcodesPostcodecountryCodeDaysDateGet? = nil, completion: @escaping ((_ data: UvPostcodeDayObj?,_ error: Error?) -> Void)) {
        postcodesPostcodecountryCodeDaysDateGetWithRequestBuilder(postcode: postcode, countryCode: countryCode, date: date, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A day of UV data for a postcode.
     - GET /postcodes/{postcode},{countryCode}/days/{date}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "uv" : [ {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  }, {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  } ],
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+00:00",
    "dateEnd" : "2019-12-20T00:00:00.000+00:00"
  },
  "location" : {
    "elevation" : 173.5,
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "postcode" : "22222",
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndexMax" : "UV Index (unitless)"
    }
  }
}}]
     - parameter postcode: (path) A postcode string. 
     - parameter countryCode: (path) An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). 
     - parameter date: (path) An date formatted as a RFC3339 date value. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvPostcodeDayObj> 
     */
    open class func postcodesPostcodecountryCodeDaysDateGetWithRequestBuilder(postcode: String, countryCode: String, date: Date, fields: [String], unitScale: UnitScale_postcodesPostcodecountryCodeDaysDateGet? = nil) -> RequestBuilder<UvPostcodeDayObj> {
        var path = "/postcodes/{postcode},{countryCode}/days/{date}"
        let postcodePreEscape = "\(postcode)"
        let postcodePostEscape = postcodePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{postcode}", with: postcodePostEscape, options: .literal, range: nil)
        let countryCodePreEscape = "\(countryCode)"
        let countryCodePostEscape = countryCodePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{countryCode}", with: countryCodePostEscape, options: .literal, range: nil)
        let datePreEscape = "\(date)"
        let datePostEscape = datePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{date}", with: datePostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvPostcodeDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_postcodesPostcodecountryCodeDaysDateStartdateEndGet: String { 
        case timestampinit = "timestampInit"
        case uvindexmax = "uvIndexMax"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_postcodesPostcodecountryCodeDaysDateStartdateEndGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A contiguous range of daily UV data for a postcode.

     - parameter postcode: (path) A postcode string. 
     - parameter countryCode: (path) An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). 
     - parameter dateStart: (path) An date formatted as a RFC3339 date value that must occur temporally before dateEnd. 
     - parameter dateEnd: (path) An date formatted as a RFC3339 date value that must occur temporally after dateStart. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func postcodesPostcodecountryCodeDaysDateStartdateEndGet(postcode: String, countryCode: String, dateStart: Date, dateEnd: Date, fields: [String], unitScale: UnitScale_postcodesPostcodecountryCodeDaysDateStartdateEndGet? = nil, completion: @escaping ((_ data: UvPostcodeDayObj?,_ error: Error?) -> Void)) {
        postcodesPostcodecountryCodeDaysDateStartdateEndGetWithRequestBuilder(postcode: postcode, countryCode: countryCode, dateStart: dateStart, dateEnd: dateEnd, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A contiguous range of daily UV data for a postcode.
     - GET /postcodes/{postcode},{countryCode}/days/{dateStart},{dateEnd}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "uv" : [ {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  }, {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  } ],
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+00:00",
    "dateEnd" : "2019-12-20T00:00:00.000+00:00"
  },
  "location" : {
    "elevation" : 173.5,
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "postcode" : "22222",
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndexMax" : "UV Index (unitless)"
    }
  }
}}]
     - parameter postcode: (path) A postcode string. 
     - parameter countryCode: (path) An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). 
     - parameter dateStart: (path) An date formatted as a RFC3339 date value that must occur temporally before dateEnd. 
     - parameter dateEnd: (path) An date formatted as a RFC3339 date value that must occur temporally after dateStart. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvPostcodeDayObj> 
     */
    open class func postcodesPostcodecountryCodeDaysDateStartdateEndGetWithRequestBuilder(postcode: String, countryCode: String, dateStart: Date, dateEnd: Date, fields: [String], unitScale: UnitScale_postcodesPostcodecountryCodeDaysDateStartdateEndGet? = nil) -> RequestBuilder<UvPostcodeDayObj> {
        var path = "/postcodes/{postcode},{countryCode}/days/{dateStart},{dateEnd}"
        let postcodePreEscape = "\(postcode)"
        let postcodePostEscape = postcodePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{postcode}", with: postcodePostEscape, options: .literal, range: nil)
        let countryCodePreEscape = "\(countryCode)"
        let countryCodePostEscape = countryCodePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{countryCode}", with: countryCodePostEscape, options: .literal, range: nil)
        let dateStartPreEscape = "\(dateStart)"
        let dateStartPostEscape = dateStartPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dateStart}", with: dateStartPostEscape, options: .literal, range: nil)
        let dateEndPreEscape = "\(dateEnd)"
        let dateEndPostEscape = dateEndPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dateEnd}", with: dateEndPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvPostcodeDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_postcodesPostcodecountryCodeDaysGet: String { 
        case timestampinit = "timestampInit"
        case uvindexmax = "uvIndexMax"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_postcodesPostcodecountryCodeDaysGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     The complete daily UV forecast for a postcode.

     - parameter postcode: (path) A postcode string. 
     - parameter countryCode: (path) An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func postcodesPostcodecountryCodeDaysGet(postcode: String, countryCode: String, fields: [String], unitScale: UnitScale_postcodesPostcodecountryCodeDaysGet? = nil, completion: @escaping ((_ data: UvPostcodeDayObj?,_ error: Error?) -> Void)) {
        postcodesPostcodecountryCodeDaysGetWithRequestBuilder(postcode: postcode, countryCode: countryCode, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     The complete daily UV forecast for a postcode.
     - GET /postcodes/{postcode},{countryCode}/days

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "uv" : [ {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  }, {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndexMax" : 10
  } ],
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+00:00",
    "dateEnd" : "2019-12-20T00:00:00.000+00:00"
  },
  "location" : {
    "elevation" : 173.5,
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "postcode" : "22222",
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndexMax" : "UV Index (unitless)"
    }
  }
}}]
     - parameter postcode: (path) A postcode string. 
     - parameter countryCode: (path) An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvPostcodeDayObj> 
     */
    open class func postcodesPostcodecountryCodeDaysGetWithRequestBuilder(postcode: String, countryCode: String, fields: [String], unitScale: UnitScale_postcodesPostcodecountryCodeDaysGet? = nil) -> RequestBuilder<UvPostcodeDayObj> {
        var path = "/postcodes/{postcode},{countryCode}/days"
        let postcodePreEscape = "\(postcode)"
        let postcodePostEscape = postcodePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{postcode}", with: postcodePostEscape, options: .literal, range: nil)
        let countryCodePreEscape = "\(countryCode)"
        let countryCodePostEscape = countryCodePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{countryCode}", with: countryCodePostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvPostcodeDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_postcodesPostcodecountryCodeHoursGet: String { 
        case timestampinit = "timestampInit"
        case uvindex = "uvIndex"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_postcodesPostcodecountryCodeHoursGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     The complete hourly UV forecast for a postcode.

     - parameter postcode: (path) A postcode string. 
     - parameter countryCode: (path) An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func postcodesPostcodecountryCodeHoursGet(postcode: String, countryCode: String, fields: [String], unitScale: UnitScale_postcodesPostcodecountryCodeHoursGet? = nil, completion: @escaping ((_ data: UvPostcodeHourObj?,_ error: Error?) -> Void)) {
        postcodesPostcodecountryCodeHoursGetWithRequestBuilder(postcode: postcode, countryCode: countryCode, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     The complete hourly UV forecast for a postcode.
     - GET /postcodes/{postcode},{countryCode}/hours

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "uv" : [ {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "elevation" : 173.5,
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "postcode" : "22222",
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndex" : "UV Index (unitless)"
    }
  }
}}]
     - parameter postcode: (path) A postcode string. 
     - parameter countryCode: (path) An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvPostcodeHourObj> 
     */
    open class func postcodesPostcodecountryCodeHoursGetWithRequestBuilder(postcode: String, countryCode: String, fields: [String], unitScale: UnitScale_postcodesPostcodecountryCodeHoursGet? = nil) -> RequestBuilder<UvPostcodeHourObj> {
        var path = "/postcodes/{postcode},{countryCode}/hours"
        let postcodePreEscape = "\(postcode)"
        let postcodePostEscape = postcodePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{postcode}", with: postcodePostEscape, options: .literal, range: nil)
        let countryCodePreEscape = "\(countryCode)"
        let countryCodePostEscape = countryCodePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{countryCode}", with: countryCodePostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvPostcodeHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_postcodesPostcodecountryCodeHoursTimestampGet: String { 
        case timestampinit = "timestampInit"
        case uvindex = "uvIndex"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_postcodesPostcodecountryCodeHoursTimestampGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     An hour of UV data for a postcode.

     - parameter postcode: (path) A postcode string. 
     - parameter countryCode: (path) An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). 
     - parameter timestamp: (path) A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func postcodesPostcodecountryCodeHoursTimestampGet(postcode: String, countryCode: String, timestamp: Date, fields: [String], unitScale: UnitScale_postcodesPostcodecountryCodeHoursTimestampGet? = nil, completion: @escaping ((_ data: UvPostcodeHourObj?,_ error: Error?) -> Void)) {
        postcodesPostcodecountryCodeHoursTimestampGetWithRequestBuilder(postcode: postcode, countryCode: countryCode, timestamp: timestamp, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     An hour of UV data for a postcode.
     - GET /postcodes/{postcode},{countryCode}/hours/{timestamp}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "uv" : [ {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "elevation" : 173.5,
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "postcode" : "22222",
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndex" : "UV Index (unitless)"
    }
  }
}}]
     - parameter postcode: (path) A postcode string. 
     - parameter countryCode: (path) An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). 
     - parameter timestamp: (path) A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvPostcodeHourObj> 
     */
    open class func postcodesPostcodecountryCodeHoursTimestampGetWithRequestBuilder(postcode: String, countryCode: String, timestamp: Date, fields: [String], unitScale: UnitScale_postcodesPostcodecountryCodeHoursTimestampGet? = nil) -> RequestBuilder<UvPostcodeHourObj> {
        var path = "/postcodes/{postcode},{countryCode}/hours/{timestamp}"
        let postcodePreEscape = "\(postcode)"
        let postcodePostEscape = postcodePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{postcode}", with: postcodePostEscape, options: .literal, range: nil)
        let countryCodePreEscape = "\(countryCode)"
        let countryCodePostEscape = countryCodePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{countryCode}", with: countryCodePostEscape, options: .literal, range: nil)
        let timestampPreEscape = "\(timestamp)"
        let timestampPostEscape = timestampPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestamp}", with: timestampPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvPostcodeHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_postcodesPostcodecountryCodeHoursTimestampStarttimestampEndGet: String { 
        case timestampinit = "timestampInit"
        case uvindex = "uvIndex"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_postcodesPostcodecountryCodeHoursTimestampStarttimestampEndGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A contiguous range of hourly UV data for a postcode.

     - parameter postcode: (path) A postcode string. 
     - parameter countryCode: (path) An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). 
     - parameter timestampStart: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. 
     - parameter timestampEnd: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func postcodesPostcodecountryCodeHoursTimestampStarttimestampEndGet(postcode: String, countryCode: String, timestampStart: Date, timestampEnd: Date, fields: [String], unitScale: UnitScale_postcodesPostcodecountryCodeHoursTimestampStarttimestampEndGet? = nil, completion: @escaping ((_ data: UvPostcodeHourObj?,_ error: Error?) -> Void)) {
        postcodesPostcodecountryCodeHoursTimestampStarttimestampEndGetWithRequestBuilder(postcode: postcode, countryCode: countryCode, timestampStart: timestampStart, timestampEnd: timestampEnd, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A contiguous range of hourly UV data for a postcode.
     - GET /postcodes/{postcode},{countryCode}/hours/{timestampStart},{timestampEnd}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "uv" : [ {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "uvIndex" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "elevation" : 173.5,
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "postcode" : "22222",
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "uvIndex" : "UV Index (unitless)"
    }
  }
}}]
     - parameter postcode: (path) A postcode string. 
     - parameter countryCode: (path) An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). 
     - parameter timestampStart: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. 
     - parameter timestampEnd: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<UvPostcodeHourObj> 
     */
    open class func postcodesPostcodecountryCodeHoursTimestampStarttimestampEndGetWithRequestBuilder(postcode: String, countryCode: String, timestampStart: Date, timestampEnd: Date, fields: [String], unitScale: UnitScale_postcodesPostcodecountryCodeHoursTimestampStarttimestampEndGet? = nil) -> RequestBuilder<UvPostcodeHourObj> {
        var path = "/postcodes/{postcode},{countryCode}/hours/{timestampStart},{timestampEnd}"
        let postcodePreEscape = "\(postcode)"
        let postcodePostEscape = postcodePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{postcode}", with: postcodePostEscape, options: .literal, range: nil)
        let countryCodePreEscape = "\(countryCode)"
        let countryCodePostEscape = countryCodePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{countryCode}", with: countryCodePostEscape, options: .literal, range: nil)
        let timestampStartPreEscape = "\(timestampStart)"
        let timestampStartPostEscape = timestampStartPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestampStart}", with: timestampStartPostEscape, options: .literal, range: nil)
        let timestampEndPreEscape = "\(timestampEnd)"
        let timestampEndPostEscape = timestampEndPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestampEnd}", with: timestampEndPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<UvPostcodeHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
